/**
 * Created by John on 7/10/2017.
 */
var fs = require("fs");
var path = require("path");
var Hash = require('../config/hash');


function JwtHelper(config) {
    this.fileName =  path.join(__dirname,  '..', '/config/.jwt');
    if (config.fileOutput && config.fileOutput.JWT) {
        this.fileName = config.fileOutput.JWT;
    }
}

JwtHelper.prototype.addUser = function(user, pass) {
    var hash = new Hash();
    var json = this.loadFile();
    if (json) {
        json[user] = hash.createHash(pass);
        this.writeFile(json);
    }
};

JwtHelper.prototype.removeUser = function(user) {
    var json = this.loadFile();
    if (json) {
        if (json[user]) delete json[user];
        this.writeFile(json);
    }
};

JwtHelper.prototype.loadFile = function() {
    var data = null;
    var json = {};
    try {
        data = fs.readFileSync(this.fileName);
    } catch (err) {
        //eat it... will create a new file
    }
    if (data) {
        json = JSON.parse(data);
    }
    return json;
};

JwtHelper.prototype.writeFile = function(json) {
    fs.writeFileSync(this.fileName, JSON.stringify(json, null, '\t'));
};

JwtHelper.prototype.checkUser = function(user, pass) {
    var hash = new Hash();
    var json = this.loadFile();
    if (json) {
        if (json[user]) {
            return hash.isValidPassword({password: json[user]}, pass);
        } else {
            return false;
        }
    } else {
        return false;
    }
};

JwtHelper.prototype.listUsers = function(user, pass) {
    if (this.checkUser(user, pass)) {
        var json = this.loadFile();
        if (!json) {
            return ["NONE!"];
        } else {
            return Object.keys(json);
        }
    } else {
        return ["INVALID CREDENTIALS!"];
    }
};

module.exports = JwtHelper;